/*----------------------------------------------------------------------------------*/
/* Copyright 2002-2009, Distributed Systems Architecture Group, Universidad   
 * Complutense de Madrid (dsa-research.org)                                   
 *                                                                            
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
 */ 
/*-----------------------------------------------------------------------------------*/

#ifndef ONE_CONF_H
#define ONE_CONF_H

#include <config.h>

#include "internal.h"
#include "domain_conf.h"
#include "capabilities.h"

typedef struct one_driver one_driver_t;

struct one_driver
{
    PTHREAD_MUTEX_T(lock);

    virCapsPtr caps;
    virDomainObjList domains;
    int nextid;
};


virCapsPtr oneCapsInit(void);
int oneSubmitVM(virConnectPtr conn ,one_driver_t* driver, virDomainObjPtr  vm);
int xmlOneTemplate(virDomainDefPtr def, FILE* fd);

#define oneError(conn, dom, code, fmt...)                                    \
        virReportErrorHelper(conn, VIR_FROM_ONE, code, __FILE__,           \
                               __FUNCTION__, __LINE__, fmt)

#endif /* ONE_CONF_H */

